import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(int id, String name) {
    Professor emp = new Professor();
    emp.setId(id);
    emp.setName(name);
    em.persist(emp);
    return emp;
  }

  public void removeProfessor(int id) {
    Professor emp = findProfessor(id);
    if (emp != null) {
      em.remove(emp);
    }
  }

  public Professor changeProfessorName(int id, String newName) {
    Professor emp = findProfessor(id);
    if (emp != null) {
      emp.setName(newName);
    }
    return emp;
  }

  public Professor findProfessor(int id) {
    return em.find(Professor.class, id);
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }

}